//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 PaleVioletRed
#property indicator_color2 DeepSkyBlue
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern int    EmaPeriod        = 13;
extern int    MacdFastPeriod   = 12;
extern int    MacdSlowPeriod   = 26;
extern int    MacdSignalPeriod =  9;
extern int    Price            = PRICE_CLOSE;

//
//
//
//
//

double impulseDn[];
double impulseUp[];

//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   SetIndexBuffer(0, impulseDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1, impulseUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double work[][4];
#define _ema   0
#define _macdv 1
#define _macds 2
#define _macdo 3

//
//
//
//
//

int start()
{
   double alpha = 2.0 / (1.0+MacdSignalPeriod);
   int i,r,limit,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(work,0) != Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-i-1; i>=0; i--,r++)
   {
      work[r][_ema]   = iMA(NULL,0,EmaPeriod,0,MODE_EMA,Price,i); 
      work[r][_macdv] = iMA(NULL,0,MacdFastPeriod,0,MODE_EMA,Price,i)-iMA(NULL,0,MacdSlowPeriod,0,MODE_EMA,Price,i);
      work[r][_macds] = work[r-1][_macds]+alpha*(work[r][_macdv]-work[r-1][_macds]);
      work[r][_macdo] = work[r][_macdv]-work[r][_macds];
       
      //
      //
      //
      //
      //
         
      impulseDn[i]=EMPTY_VALUE;
      impulseUp[i]=EMPTY_VALUE;
            double cOpen  = Open[i];
            double cClose = Close[i];
      if (work[r][_ema]<work[r-1][_ema] && work[r][_macdo]<work[r-1][_macdo]) { impulseDn[i]=MathMax(cClose,cOpen); impulseUp[i]=MathMin(cClose,cOpen); }
      if (work[r][_ema]>work[r-1][_ema] && work[r][_macdo]>work[r-1][_macdo]) { impulseDn[i]=MathMin(cClose,cOpen); impulseUp[i]=MathMax(cClose,cOpen); }
   }
   return(0);
}